#include "MB_Directive.h"
#include "MB_Debug.h"
#include "MB_InterfaceL1.h"

const bool cboDebugModuleOn = false;

// Declare external debug trace object for MB_Debug.cpp.
//extern tclDebugTrace _vclDebugTrace;

//	Declare external interface level 1 object.
//extern tclInterfaceL1 _vclInterfaceL1;

#define macCreateEntityFunc(mapClassName) \
extern "C" EXPORT void mapClassName ( entvars_t *pev ); \
void mapClassName ( entvars_t *pev ) \
{ \
	static tfn_ptrEntity vfn_ptrEntity = NULL; \
	static int vinSkip = 0; \
	if (vinSkip) \
		return; \
   if (vfn_ptrEntity == NULL) \
		vfn_ptrEntity = \
			(tfn_ptrEntity)GetProcAddress	\
				(vclInterfaceL1.fna_ptrGetGameDLLPtr(), #mapClassName); \
   if (vfn_ptrEntity == NULL) \
	{ \
		vinSkip = 1; \
		return; \
   } \
	vclInterfaceL1.fvoExecuteOn_CreateEntity_DLL	\
		(#mapClassName); \
	if (vclInterfaceL1.fboCanceled() == true) \
	{ \
		return; \
	} \
	vclDebugTrace.fvoWriteEventInfo(cboDebugModuleOn, #mapClassName "_ENTITY: About to run original." ); \
   (*vfn_ptrEntity)(pev); \
	vclDebugTrace.fvoWriteEventInfo(cboDebugModuleOn, #mapClassName "_ENTITY: Run OK." ); \
} \


//CountTeamPlayers
//CountTeams
//GetEntityAPI
//GetNewDLLFunctions
//GiveFnptrsToDll
//Server_GetBlendingInterface

macCreateEntityFunc (DelayedUse);
macCreateEntityFunc (ambient_generic);
macCreateEntityFunc (ammo_338magnum);
macCreateEntityFunc (ammo_357sig);
macCreateEntityFunc (ammo_45acp);
macCreateEntityFunc (ammo_50ae);
macCreateEntityFunc (ammo_556nato);
macCreateEntityFunc (ammo_556natobox);
macCreateEntityFunc (ammo_57mm);
macCreateEntityFunc (ammo_762nato);
macCreateEntityFunc (ammo_9mm);
macCreateEntityFunc (ammo_buckshot);
macCreateEntityFunc (armoury_entity);
macCreateEntityFunc (beam);
macCreateEntityFunc (bodyque);
macCreateEntityFunc (button_target);
macCreateEntityFunc (cycler);
macCreateEntityFunc (cycler_prdroid);
macCreateEntityFunc (cycler_sprite);
macCreateEntityFunc (cycler_weapon);
macCreateEntityFunc (cycler_wreckage);
macCreateEntityFunc (env_beam);
macCreateEntityFunc (env_beverage);
macCreateEntityFunc (env_blood);
macCreateEntityFunc (env_bombglow);
macCreateEntityFunc (env_bubbles);
macCreateEntityFunc (env_debris);
macCreateEntityFunc (env_explosion);
macCreateEntityFunc (env_fade);
macCreateEntityFunc (env_funnel);
macCreateEntityFunc (env_global);
macCreateEntityFunc (env_glow);
macCreateEntityFunc (env_laser);
macCreateEntityFunc (env_lightning);
macCreateEntityFunc (env_message);
macCreateEntityFunc (env_rain);
macCreateEntityFunc (env_render);
macCreateEntityFunc (env_shake);
macCreateEntityFunc (env_shooter);
macCreateEntityFunc (env_snow);
macCreateEntityFunc (env_sound);
macCreateEntityFunc (env_spark);
macCreateEntityFunc (env_sprite);
macCreateEntityFunc (fireanddie);
macCreateEntityFunc (func_bomb_target);
macCreateEntityFunc (func_breakable);
macCreateEntityFunc (func_button);
macCreateEntityFunc (func_buyzone);
macCreateEntityFunc (func_conveyor);
macCreateEntityFunc (func_door);
macCreateEntityFunc (func_door_rotating);
macCreateEntityFunc (func_escapezone);
macCreateEntityFunc (func_friction);
macCreateEntityFunc (func_grencatch);
macCreateEntityFunc (func_guntarget);
macCreateEntityFunc (func_healthcharger);
macCreateEntityFunc (func_hostage_rescue);
macCreateEntityFunc (func_illusionary);
macCreateEntityFunc (func_ladder);
macCreateEntityFunc (func_monsterclip);
macCreateEntityFunc (func_mortar_field);
macCreateEntityFunc (func_pendulum);
macCreateEntityFunc (func_plat);
macCreateEntityFunc (func_platrot);
macCreateEntityFunc (func_pushable);
macCreateEntityFunc (func_rain);
macCreateEntityFunc (func_recharge);
macCreateEntityFunc (func_rot_button);
macCreateEntityFunc (func_rotating);
macCreateEntityFunc (func_snow);
macCreateEntityFunc (func_tank);
macCreateEntityFunc (func_tankcontrols);
macCreateEntityFunc (func_tanklaser);
macCreateEntityFunc (func_tankmortar);
macCreateEntityFunc (func_tankrocket);
macCreateEntityFunc (func_trackautochange);
macCreateEntityFunc (func_trackchange);
macCreateEntityFunc (func_tracktrain);
macCreateEntityFunc (func_train);
macCreateEntityFunc (func_traincontrols);
macCreateEntityFunc (func_vehicle);
macCreateEntityFunc (func_vehiclecontrols);
macCreateEntityFunc (func_vip_safetyzone);
macCreateEntityFunc (func_wall);
macCreateEntityFunc (func_wall_toggle);
macCreateEntityFunc (func_water);
macCreateEntityFunc (func_weaponcheck);
macCreateEntityFunc (g_flTimeLimit);
macCreateEntityFunc (game_counter);
macCreateEntityFunc (game_counter_set);
macCreateEntityFunc (game_end);
macCreateEntityFunc (game_player_equip);
macCreateEntityFunc (game_player_hurt);
macCreateEntityFunc (game_player_team);
macCreateEntityFunc (game_score);
macCreateEntityFunc (game_team_master);
macCreateEntityFunc (game_team_set);
macCreateEntityFunc (game_text);
macCreateEntityFunc (game_zone_player);
macCreateEntityFunc (gibshooter);
macCreateEntityFunc (grenade);
macCreateEntityFunc (hostage_entity);
macCreateEntityFunc (info_bomb_target);
macCreateEntityFunc (info_hostage_rescue);
macCreateEntityFunc (info_intermission);
macCreateEntityFunc (info_landmark);
macCreateEntityFunc (info_map_parameters);
macCreateEntityFunc (info_null);
macCreateEntityFunc (info_player_deathmatch);
macCreateEntityFunc (info_player_start);
macCreateEntityFunc (info_target);
macCreateEntityFunc (info_teleport_destination);
macCreateEntityFunc (info_vip_start);
macCreateEntityFunc (infodecal);
macCreateEntityFunc (item_airtank);
macCreateEntityFunc (item_antidote);
macCreateEntityFunc (item_assaultsuit);
macCreateEntityFunc (item_battery);
macCreateEntityFunc (item_healthkit);
macCreateEntityFunc (item_kevlar);
macCreateEntityFunc (item_longjump);
macCreateEntityFunc (item_security);
macCreateEntityFunc (item_sodacan);
macCreateEntityFunc (item_suit);
macCreateEntityFunc (item_thighpack);
macCreateEntityFunc (light);
macCreateEntityFunc (light_environment);
macCreateEntityFunc (light_spot);
macCreateEntityFunc (momentary_door);
macCreateEntityFunc (momentary_rot_button);
macCreateEntityFunc (monster_hevsuit_dead);
macCreateEntityFunc (monster_mortar);
macCreateEntityFunc (monster_scientist);
macCreateEntityFunc (multi_manager);
macCreateEntityFunc (multisource);
macCreateEntityFunc (path_corner);
macCreateEntityFunc (path_track);
macCreateEntityFunc (player);
macCreateEntityFunc (player_loadsaved);
macCreateEntityFunc (player_weaponstrip);
macCreateEntityFunc (soundent);
macCreateEntityFunc (spark_shower);
macCreateEntityFunc (speaker);
macCreateEntityFunc (target_cdaudio);
macCreateEntityFunc (test_effect);
macCreateEntityFunc (trigger);
macCreateEntityFunc (trigger_auto);
macCreateEntityFunc (trigger_autosave);
macCreateEntityFunc (trigger_camera);
macCreateEntityFunc (trigger_cdaudio);
macCreateEntityFunc (trigger_changelevel);
macCreateEntityFunc (trigger_changetarget);
macCreateEntityFunc (trigger_counter);
macCreateEntityFunc (trigger_endsection);
macCreateEntityFunc (trigger_gravity);
macCreateEntityFunc (trigger_hurt);
macCreateEntityFunc (trigger_monsterjump);
macCreateEntityFunc (trigger_multiple);
macCreateEntityFunc (trigger_once);
macCreateEntityFunc (trigger_push);
macCreateEntityFunc (trigger_relay);
macCreateEntityFunc (trigger_teleport);
macCreateEntityFunc (trigger_transition);
macCreateEntityFunc (weapon_ak47);
macCreateEntityFunc (weapon_aug);
macCreateEntityFunc (weapon_awp);
macCreateEntityFunc (weapon_c4);
macCreateEntityFunc (weapon_deagle);
macCreateEntityFunc (weapon_elite);
macCreateEntityFunc (weapon_famas);
macCreateEntityFunc (weapon_fiveseven);
macCreateEntityFunc (weapon_flashbang);
macCreateEntityFunc (weapon_g3sg1);
macCreateEntityFunc (weapon_galil);
macCreateEntityFunc (weapon_glock18);
macCreateEntityFunc (weapon_hegrenade);
macCreateEntityFunc (weapon_knife);
macCreateEntityFunc (weapon_m249);
macCreateEntityFunc (weapon_m3);
macCreateEntityFunc (weapon_m4a1);
macCreateEntityFunc (weapon_mac10);
macCreateEntityFunc (weapon_mp5navy);
macCreateEntityFunc (weapon_p228);
macCreateEntityFunc (weapon_p90);
macCreateEntityFunc (weapon_scout);
macCreateEntityFunc (weapon_sg550);
macCreateEntityFunc (weapon_sg552);
macCreateEntityFunc (weapon_shield);
macCreateEntityFunc (weapon_smokegrenade);
macCreateEntityFunc (weapon_tmp);
macCreateEntityFunc (weapon_ump45);
macCreateEntityFunc (weapon_usp);
macCreateEntityFunc (weapon_xm1014);
macCreateEntityFunc (weaponbox);
macCreateEntityFunc (world_items);
macCreateEntityFunc (worldspawn);
//.e	Create entity functions.

// CS 1.6 New Weapon Entities
// weapon_famas
// weapon_galil
// weapon_shield