//.b 	
//	Copyright 2001 [MEAN].BOT
//	
//	File: MG_Lib.h
//	
//	[MEAN] General Library Definitions and Routines. 
//
//.e	

//.b skip over if header has already been included.
	#ifndef defMG_Lib_h

	// Prevent the reprocessing of this definition file by defining 
	// the alias used in the above "ifndef" check.
		#define defMG_Lib_h

	// Include all general definition files.
		#include "MB_Includes.h"

		bool fboCharStrIsOK( char *pch_ptr, unsigned long pinMaxLen );
		void fvoCharStrCopy( char *pch_ptrDest, char *pch_ptrSrc, unsigned long pinMaxLen );
		void fvoMakeCharStrReadable ( char *pch_ptrDest, char *pch_ptrSrc, unsigned long pinMaxLen );
		string ftxToUpper( string ptxString );
		void fvoToUpper( string &ptxString );
		string ftxToLower( string ptxString );
		void fvoToLower( string &ptxString );
		string ftxTrunc( string ptxString, unsigned int pinLength );
		void fvoTrunc( string &ptxString, unsigned int pinLength );
		int finStringToInt( string ptxString );
		unsigned int finStringToUInt( string ptxString );
		string ftxIntToString( int pinValue );
		string ftxIntToString( unsigned int pinValue );
		string ftxIntToString( long plgValue );
		float fflStringToFloat( string ptxString );
		string ftxFloatToString( float pflValue );
		string ftxFloatToString( float pflValue, int pinPrecision );
		string ftxVectorToString( Vector pstV );
		string ftxBoolToString( bool pboBool, string ptxTrueStr = "yes", string ptxFalseStr = "no" );
		string fxtFillLead( string ptxInStr, unsigned long plgWidth, char pchFill );
		string fxtFillTrail( string ptxInStr, unsigned long plgWidth, char pchFill );
		string ftxIntToStringF( long plgValue, unsigned long plgWidth, char pchFillDir, char pchFill );
		string ftxTrimL( string ptxInStr );
		string ftxTrimR( string ptxInStr );
		string ftxTrim( string ptxInStr );
		bool fboFileExists( string ptxFileName );
		bool fboFileCanBeRead( string ptxFileName );
		bool fboFileCanBeWritten( string ptxFileName );
		int finRandom( int pinMin, int pinMax );
		float fflMinOf( float pflV1, float pflV2 );
		float fflMaxOf( float pflV1, float pflV2 );

		void fvoOrderMinMax_Float( float &pflMin, float &pflMax );
		void fvoOrderMinMax_Long( long &pinMin, long &pinMax );
		void fvoOrderMinMax_Int( int &pinMin, int &pinMax );
		float fflBoundValue( float pflValue, float pflMin, float pflMax );
		long finBoundValue( long pinValue, long pinMin, long pinMax );
		bool fboInRange_Int( int pinValue, int pinMin, int pinMax );
		bool fboInRange_Long( long pinValue, long pinMin, long pinMax );
		bool fboInRange_Float( float pflValue, float pflMin, float pflMax );
		bool fboIsOn( string ptxSwitch );
		bool fboIsOff( string ptxSwitch );

	#endif // defMG_Lib_h
//.e skip over if header has already been included.

