//.b 	
//	Copyright 2001 [MEAN].BOT
//	
//	File: MI_Hud.cpp
//	
//	[MEAN] "Heads Up Display" class definitions.
//
//.e	

	#include "MB_Includes.h"	
	#include "MI_Hud.h"
	#include "MG_Lib.h"
	#include "MA_Player.h"
	#include "MA_Sched.h"

	void tclHUD::fvoCenterSay( string ptxMsg, bool pboTrace )
	{

		if ( ptxMsg.empty( ) )
			return;

	// Print using the teletype effect
		hudtextparms_t m_textParms;
		m_textParms.r1 = 255;
		m_textParms.g1 = 250;
		m_textParms.b1 = 0;
		m_textParms.a1 = 0;
		m_textParms.r2 = 255;
		m_textParms.g2 = 255;
		m_textParms.b2 = 250;                                                            
		m_textParms.a2 = 0;   
		m_textParms.fadeinTime = 0.02;
		m_textParms.fadeoutTime = 0;
		m_textParms.holdTime = 7;
		m_textParms.fxTime = 0.07;
		m_textParms.effect = 2;
		m_textParms.x = 0.05;
		m_textParms.y = 0.7;
		m_textParms.channel = 1;

		fvoTrunc( ptxMsg, cinMaxMsgLen );

		if ( pboTrace )
			vclDebugTrace.fvoWriteEventInfo ( true, ptxMsg );	
		
		UTIL_HudMessageAll( m_textParms, ptxMsg.c_str( ) );

	} // tclHUD::fvoCenterSay

	void tclHUD::fvoISay( edict_t* pst_ptrEdict, string ptxMsg )
	{
		if ( ptxMsg.empty( ) )
			return;

		string vtxName;

		if ( pst_ptrEdict ==  NULL )
			vtxName = "Server Operator";
		else
			vtxName = vclPlayer.ftxGetPlayerNameByEdict( pst_ptrEdict );

		vtxName += " says:";

		hudtextparms_t m_textParms;

		m_textParms.r1 = 0;
		m_textParms.g1 = 255;
		m_textParms.b1 = 0;
		m_textParms.a1 = 0;
		m_textParms.r2 = 0;
		m_textParms.g2 = 255;
		m_textParms.b2 = 0;                                                            
		m_textParms.a2 = 0;   
		m_textParms.fadeinTime = 0.02;
		m_textParms.fadeoutTime = 0;
		m_textParms.holdTime = 7;
		m_textParms.fxTime = 0.07;
		m_textParms.effect = 2;
		m_textParms.x = 0.05;
		m_textParms.y = 0.7;
		m_textParms.channel = 1;

		fvoTrunc( vtxName, cinMaxMsgLen );
		vclDebugTrace.fvoWriteEventInfo ( true, vtxName );
		UTIL_HudMessageAll( m_textParms, vtxName.c_str( ) );

		m_textParms.r1 = 255;
		m_textParms.g1 = 250;
		m_textParms.b1 = 0;
		m_textParms.a1 = 0;
		m_textParms.r2 = 255;
		m_textParms.g2 = 255;
		m_textParms.b2 = 250;                                                            
		m_textParms.a2 = 0;   
		m_textParms.fadeinTime = 0.02;
		m_textParms.fadeoutTime = 0;
		m_textParms.holdTime = 7;
		m_textParms.fxTime = 0.07;
		m_textParms.effect = 2;
		m_textParms.x = 0.05;
		m_textParms.y = 0.72;
		m_textParms.channel = 2;

		fvoTrunc( ptxMsg, cinMaxMsgLen );
		vclDebugTrace.fvoWriteEventInfo( true, ptxMsg );
		UTIL_HudMessageAll( m_textParms, ptxMsg.c_str( ) );

	} // tclHUD::fvoISay

	void tclHUD::fvoCenterSayRed( string ptxMsg, bool pboTrace )
	{

		if ( ptxMsg.empty( ) )
			return;
		
		fvoToUpper (ptxMsg);

	// Print using the teletype effect
		hudtextparms_t m_textParms;
		m_textParms.r1 = 255;
		m_textParms.g1 = 0;
		m_textParms.b1 = 0;
		m_textParms.a1 = 0;
		m_textParms.r2 = 255;
		m_textParms.g2 = 0;
		m_textParms.b2 = 0;                                                            
		m_textParms.a2 = 0;   
//		m_textParms.fadeinTime = 3;
		m_textParms.fadeinTime = 1;
		m_textParms.fadeoutTime = 5;
		m_textParms.holdTime = 7;
		m_textParms.fxTime = 0.2;
		m_textParms.effect = 0;
		m_textParms.x = 0.05;
		m_textParms.y = 0.6;
		m_textParms.channel = 3;

		fvoTrunc( ptxMsg, cinMaxMsgLen );
		if ( pboTrace )
			vclDebugTrace.fvoWriteEventInfo ( true, ptxMsg );
		UTIL_HudMessageAll(m_textParms, ptxMsg.c_str());

	} // tclHUD::fvoCenterSayRed

	void tclHUD::fvoCenterSayBlue( string ptxMsg, bool pboTrace )
	{

		if ( ptxMsg.empty( ) )
			return;
		
		//!! removed - fvoToUpper( ptxMsg );

	// Print using the teletype effect
		hudtextparms_t m_textParms;
		m_textParms.r1 = 50;
		m_textParms.g1 = 50;
		m_textParms.b1 = 255;
		m_textParms.a1 = 0;
		m_textParms.r2 = 50;
		m_textParms.g2 = 50;
		m_textParms.b2 = 255;                                                            
		m_textParms.a2 = 0;   
		m_textParms.fadeinTime = 1;
		m_textParms.fadeoutTime = 5;
		m_textParms.holdTime = 15;
		m_textParms.fxTime = 0.2;
		m_textParms.effect = 0;
		m_textParms.x = 0.10;
		m_textParms.y = 0.4;
		m_textParms.channel = 4;

		fvoTrunc( ptxMsg, cinMaxMsgLen );
		if ( pboTrace )
			vclDebugTrace.fvoWriteEventInfo ( true, ptxMsg );
		UTIL_HudMessageAll( m_textParms, ptxMsg.c_str( ) );

	} // tclHUD::fvoCenterSayBlue

	void tclHUD::fvoStatusSay( string ptxMsg, bool pboTrace )
	{
		if ( ptxMsg.empty( ) )
			return;

		hudtextparms_t m_textParms;
		m_textParms.r1 = 0;
		m_textParms.g1 = 255;
		m_textParms.b1 = 0;
		m_textParms.a1 = 0;
		m_textParms.r2 = 0;
		m_textParms.g2 = 255;
		m_textParms.b2 = 0;                                                            
		m_textParms.a2 = 0;   
		m_textParms.fadeinTime = 2.0;
		m_textParms.fadeoutTime = 2.0;
		m_textParms.holdTime = 7;
		m_textParms.fxTime = 0.2;
		m_textParms.effect = 0;
		m_textParms.x = 0.02;
		m_textParms.y = 0.84;
		m_textParms.channel = 2;

		fvoTrunc( ptxMsg, cinMaxMsgLen );
		if ( pboTrace )
			vclDebugTrace.fvoWriteEventInfo( true, ptxMsg );
		UTIL_HudMessageAll( m_textParms, ptxMsg.c_str( ) );

	} // tclHUD::fvoStatusSay

	void tclHUD::fvoCenterMessageAll( string ptxMsg )
	{
		if ( ptxMsg.empty( ) )
			return;

		UTIL_CenterMessageAll( ptxMsg.c_str( ) );

	} // tclHUD::fvoCenterMessageAll

	void tclHUD::fvoChatMessageAll (string ptxMsg)
	{
		if (ptxMsg.empty())
			return;

		UTIL_ChatMessageAll( ptxMsg.c_str() );
		//UTIL_ShowMessageAll(ptxMsg.c_str());

	} // tclHUD::fvoChatMessageAll

	void tclHUD::fvoSayWithDelay( string vtxMsgType, string ptxMsg, float vflDelay )
	{
		if ( vclEventSched.fboCreateEvent( ) )
		{
			vclEventSched.fboCreateArgList( 2 );
			vclEventSched.fvoSetArg_String( 0, vtxMsgType ); // specify HUD display;
			vclEventSched.fvoSetArg_String( 1, ptxMsg );
			vclEventSched.fvoSetEventFunc( fvoMI_HUD_Event_HUDDisplay );
			vclEventSched.fvoSetDelayInSecs( vflDelay );
			vclEventSched.fboSendEvent( );
		}
	} // tclHUD::fvoSayWithDelay

	tclHUD vclHUD;

	// ===========================================================
	// General Event Functions
	// ===========================================================

	void fvoMI_HUD_Event_HUDDisplay( tclArgList& pclArgList )
	{
		string vtxHUD = pclArgList.ftxGetArg_String( 0 );
		string vtxMsg = pclArgList.ftxGetArg_String( 1 );

		if ( vtxHUD == "status"  )
			vclHUD.fvoStatusSay( vtxMsg );
		else 
		if ( vtxHUD == "center"  )
		 vclHUD.fvoCenterSay( vtxMsg );
		else 
		if ( vtxHUD == "red"  )
		 vclHUD.fvoCenterSayRed( vtxMsg );
		else 
		if ( vtxHUD == "blue"  )
		 vclHUD.fvoCenterSayBlue( vtxMsg );

	} // fvoMI_HUD_Event_HUDDisplay